<?php
/*
+---------------------------------------------------------------+
|	e107 website system
|	/config/dialog_class.php
|
|	 Torsten Stelling 2004
|	http://www.dev0.de
|	murphy@dev0.de
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/

require_once(e_HANDLER."userclass_class.php");
require_once(e_HANDLER."ren_help.php");

// ************************************************************
// ************************************************************
// **                                                        **
// ** class dialog                                           **
// **                                                        **
// ************************************************************
// **                                                        **
// ** This class adds easy formular creation to the          **
// ** configuration area in e107. You can also use this      **
// ** class in normal e107. It should run fine.              **
// **                                                        **
// ************************************************************
// ************************************************************

class dialog {
	var $dlg;        // created dialog string
	var $columns;    // columns of dialog
	var $itemstyle1;
	var $itemstyle2;
	var $fid;        // form id information
	var $helpb;      // marker for bbcode help function

	// ************************************************************
	// ** properties to set for dialog
	// ************************************************************

	function columns($cols=2) {
		$this->columns=$cols;
	}

	function columnstyle($style="",$style2="") {
		$this->itemstyle1=$style;
		$this->itemstyle2=$style2;
	}

	// ************************************************************
	// ** initilization and finalization
	// ************************************************************

	function clear() {
		$this->dlg = "";
		$this->columns=2;
		$this->itemstyle1="";
		$this->itemstyle2="";
		$this->helpb=FALSE;
	}

	function init() {
		$this->dlg .= "<table width='100%'>";
	}

	function done() {
		$this->dlg .= "</table>";
	}

	function openclose($title,$visible="none") {
		$this->dlg .= ($title==""?"</div>":"<div class='caption' title='Click here to view' ".
			"style='cursor:pointer;cursor:hand;text-align:left;border:1px solid black' onclick=\"expandit(this)\">$title</div>".
			"<div id='theme'".($visible=="none"?" style='display:none'":"").">");
	}

	function openclosed($title,$visible="none") {
		$this->dlg .= ($title==""?"</div>":
			"<div class='forumheader' title='Click here to view' ".
			"style='cursor:pointer;cursor:hand;text-align:center;' onclick=\"expandit(this)\">$title</div>".
			"<div id='theme'".($visible=="none"?" style='display:none'":"").">");
	}

	// ************************************************************
	// ** caption and text items
	// ************************************************************

	function caption($title="",$style="text-align:center") {
		if ($title !="") {
			$this->dlg .= "<tr><td ".
				(($this->columns>1)?"colspan='".$this->columns."' ":"").
				($style?"style='".$style."'":"")." class='forumheader'>$title</td></tr>";
		}
	}

	function text($text="",$style="text-align:center") {
		if ($text !="") {
			$this->dlg .= "<tr><td ".
				(($this->columns>1)?"colspan='".$this->columns."' ":"").
				($style?"style='".$style."'":"")." class='forumheader3'>$text</td></tr>";
		}
	}

	// ************************************************************
	// ** html stuff for the dialog
	// ************************************************************

	function htmlitem($text="",$html="",$style1="",$style2="") {
		if ($text !="") {
			$this->dlg .= "<tr><td ".
				($style1==""?"":"style='vertical-align: top; $style1' ").
				"' class='forumheader3'>$text</td><td ".
				($style2==""?"":"style='vertical-align: top; $style2' ").
				(($this->columns>2)?"colspan='".(($this->columns)-1)."' ":"").
				"class='forumheader3'>$html</td></tr>";
		}
	}

	function htmlitemc($text="",$html="",$style1="",$style2="") {
		if ($text !="") {
			$this->dlg .= "<tr><td ".
				($style1==""?"":"style='$style1' ").
				"' class='forumheader3'>$text</td><td ".
				($style2==""?"":"style='$style2' ").
				(($this->columns>2)?"colspan='".(($this->columns)-1)."' ":"").
				"class='forumheader3'>$html</td></tr>";
		}
	}
	
	function html($html="") {
		$this->dlg .= $html;
	}
	
	// ************************************************************
	// ** several easy item to use dialog item
	// ************************************************************

	function startitem($style="",$html="",$cls="forumheader3",$td="") {
		$this->dlg .= "<tr><td ".($td?$td." ":"").
			"style='vertical-align:top; $style' class='$cls'>$html";
	}

	function nextitem($style="",$html="",$cls="forumheader3",$td="") {
		$this->dlg .= "</td><td ".($td?$td." ":"").
			"style='vertical-align:top; $style' class='$cls'>$html";
	}

	function enditem() {
		$this->dlg .= "</td></tr>";
	}

	function startitemc($style="",$html="",$cls="forumheader3",$td="") {
		$this->dlg .= "<tr><td ".
			($td?$td." ":"").
			($style==""?"":"style='$style' ")."class='$cls'>$html";
	}

	function nextitemc($style="",$html="",$cls="forumheader3",$td="") {
		$this->dlg .= "</td><td ".
			($td?$td." ":"").
			($style==""?"":"style='$style' ").
			"class='$cls'>$html";
	}

	// ************************************************************
	// ** default items for dialogs
	// ************************************************************

	function button($name="btn",$value="btn",$lnk="submit") {
		$this->dlg .= 
			"<input class='button' type='".
			($lnk=="submit"?$lnk:"button").
			"' value='$value' id='$name' name='$name' ".
			($lnk=="submit"?"/>":"onclick=\"document.location='$lnk'\" />");
	}

	function edit($name="edit",$value="",$width="45",$maxlength="") {
		$this->dlg .= "<input class='tbox' type='text' name='$name' size='$width' value='$value'".
			($maxlength==""?"":" maxlength='$maxlength'").">";
	}

	function memo($name="memo",$value="",$width="45",$height="5") {
		$this->dlg .= "<textarea class='tbox' name='$name' cols='$width' rows='$height'>$value</textarea>";
	}

	function bbmemo($name="memo",$value="",$width="45",$height="5") {
		$this->dlg .= "<textarea class='tbox' name='$name' cols='$width' rows='$height' onselect='storeCaret(this);' onclick='storeCaret(this);' onkeyup='storeCaret(this);'>$value</textarea>";
	}

	function bbcode($name="helpbox",$width="0") {
		$this->dlg .= ($width=="0"?"":"<input class='helpbox' type='text' name='".$name."' size='".$width."' /><br />").ren_help(1,"addtext",$name."d");
		if ($width!="0") { $this->helpb = TRUE; }
	}

	function helpboxscript($name="helpbox") {
		return "<script type='text/javascript'> function ".$name."d(help){ document.getElementById('".$this->fid."').".$name.".value = help; } </script>";
	}

	function checkbox($name="checkbox",$checked="") {
		$this->dlg .= "<input type='checkbox' name='$name' value='checked'".($checked?" checked":"").">";
	}

	function radiobox($name="radiobox",$value="0",$checked="") {
		$this->dlg .= "<input type='radio' name='$name' value='$value'".($checked?" checked":"").">";
	}

	function dropdownuc($name="dropdown",$userclass="0",$classes="public,guest,nobody,member,admin,classes",$mode="off") {
		$this->dlg .= r_userclass($name,$userclass,$mode,$classes);
	}

	function dropdownstart($name="dropdown") {
		$this->dlg .= "<select class='tbox' name='$name'>";
	}

	function dropdownoption($value="",$text="",$selected="") {
		$this->dlg .= "<option value='$value' ".($selected?"selected":"").">$text</option>";
	}

	function dropdownend() {
		$this->dlg .= "</select>";
	}

	// ************************************************************
	// ** several easy item to use dialog item
	// ************************************************************

	function textitem($title="text",$text="text") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,$text,"forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$this->enditem();
	}

	function buttonitem($title="btn",$name="btn",$value="btn",$lnk="submit",$more="") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,$more,"forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$this->button($name,$value,$lnk);
		$this->enditem();
	}

	function edititem($title="edit",$name="edit",$value="",$width="45",$maxlength="",$more="") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,$more,"forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$this->edit($name,$value,$width,$maxlength);
		$this->enditem();
	}

	function memoitem($title="memo",$name="memo",$value="",$width="45",$height="5",$more="") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,$more,"forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$this->memo($name,$value,$width,$height);
		$this->enditem();
	}

	function bbmemoitem($title="memo",$name="memo",$value="",$width="45",$height="5",$more="") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,$more,"forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$this->bbmemo($name,$value,$width,$height);
		$this->html("<br/>");
		$this->bbcode("hlp".$fid,$width);
		$this->enditem();
	}

	function checkboxitem($title="checkbox",$name="checkbox",$checked="",$more="") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,"","forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$this->checkbox($name,$checked);
		$this->html($more);
		$this->enditem();
	}

	function radioboxitem($title="radiobox",$name="radiobox",$textarray,$def="0",$more="") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,$more,"forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$a = 0;
		foreach($textarray as $c){
			$this->radiobox($name,$a,($a==$def?"checked":""));
			$this->html($c);
			$a = $a +1;
		}
		$this->enditem();
	}

	function dropdownucitem($title="dropdown",$name="dropdown",$userclass="0",$classes="public,guest,nobody,member,admin,classes",$mode="off",$more="") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,$more,"forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$this->dropdownuc($name,$userclass,$classes,$mode);
		$this->enditem();
	}

	function dropdownitem($title="dropdown",$name="dropdown",$textarray,$def="0",$more="") {
		$this->startitemc($this->itemstyle1,$title);
		$this->nextitemc($this->itemstyle2,$more,"forumheader3",($this->columns>2?"colspan='".(($this->columns)-1)."'":""));
		$this->dropdownstart($name);
		$a = 0;
		foreach($textarray as $c){
			$this->dropdownoption($a,$c,($a==$def?"selected":""));
			$a = $a +1;
		}
		$this->dropdownend();
		$this->enditem();
	}

	// ************************************************************
	// ** items for creating a submit form
	// ************************************************************

	function form($formid="dataform",$lnk="") {
		$this->fid=$formid;
		if ($lnk=="") {
			$this->dlg .= "<form id='$formid' method='post' action='".e_SELF."?".e_QUERY."'>";
		} else {
			$this->dlg .= "<form id='$formid' method='post' action='$lnk'>";
		}
	}

	function endform() {
		$this->dlg .= "</form>";
	}

	// ************************************************************
	// ** get the created dialog
	// ************************************************************

	function result() {
		if ($this->helpb==TRUE) { echo $this->helpboxscript("hlp".$fid); }
		return $this->dlg;
	}
}

	// ************************************************************
	// ** default items for use with startitem and nextitem
	// ************************************************************

	function button($name="btn",$value="btn",$lnk="submit") {
		return "<input class='button' type='".
			($lnk=="submit"?$lnk:"button").
			"' value='$value' id='$name' name='$name' ".
			($lnk=="submit"?"/>":"onclick=\"document.location='$lnk'\" />");
	}

	function edit($name="edit",$value="",$width="45",$maxlength="") {
		return "<input class='tbox' type='text' name='$name' size='$width' value='$value'".
			($maxlength==""?"":" maxlength='$maxlength'").">";
	}

	function memo($name="memo",$value="",$width="45",$height="5") {
		return "<textarea class='tbox' name='$name' cols='$width' rows='$height'>$value</textarea>";
	}

	function checkbox($name="checkbox",$checked="") {
		return "<input type='checkbox' name='$name' value='checked' $checked>";
	}

	function radiobox($name="radiobox",$value="0",$checked="") {
		return "<input type='radio' name='$name' value='$value'".($checked?" checked":"").">";
	}

	function dropdownuc($name="dropdown",$userclass="0",$classes="public,guest,nobody,member,admin,classes",$mode="off") {
		return r_userclass($name,$userclass,$mode,$classes);
	}

	function dropdownstart($name="dropdown") {
		return "<select class='tbox' name='$name'>";
	}

	function dropdownoption($value="",$text="",$selected="") {
		return "<option value='$value' ".($selected?"selected":"").">$text</option>";
	}

	function dropdownend() {
		return "</select>";
	}

?>
